// python wrapper for vtkPVLegacyGlyphFilter
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkPVLegacyGlyphFilter.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkPVLegacyGlyphFilter(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkPVLegacyGlyphFilter_ClassNew(); }

#ifndef DECLARED_PyvtkGlyph3D_ClassNew
extern "C" { PyObject *PyvtkGlyph3D_ClassNew(); }
#define DECLARED_PyvtkGlyph3D_ClassNew
#endif

static const char *PyvtkPVLegacyGlyphFilter_Doc =
  "vtkPVLegacyGlyphFilter - Glyph filter\n\n"
  "Superclass: vtkGlyph3D\n\n"
  "This is a subclass of vtkGlyph3D that allows selection of input\n"
  "scalars\n\n";

static PyTypeObject PyvtkPVLegacyGlyphFilter_CommunicationIds_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkPVVTKExtensionsDefaultPython.vtkPVLegacyGlyphFilter.CommunicationIds", // tp_name
  sizeof(PyIntObject), // tp_basicsize
  0, // tp_itemsize
  nullptr, // tp_dealloc
  nullptr, // tp_print
  nullptr, // tp_getattr
  nullptr, // tp_setattr
  nullptr, // tp_compare
  nullptr, // tp_repr
  nullptr, // tp_as_number
  nullptr, // tp_as_sequence
  nullptr, // tp_as_mapping
  nullptr, // tp_hash
  nullptr, // tp_call
  nullptr, // tp_str
  nullptr, // tp_getattro
  nullptr, // tp_setattro
  nullptr, // tp_as_buffer
  Py_TPFLAGS_DEFAULT, // tp_flags
  nullptr, // tp_doc
  nullptr, // tp_traverse
  nullptr, // tp_clear
  nullptr, // tp_richcompare
  0, // tp_weaklistoffset
  nullptr, // tp_iter
  nullptr, // tp_iternext
  nullptr, // tp_methods
  nullptr, // tp_members
  nullptr, // tp_getset
  &PyInt_Type, // tp_base
  nullptr, // tp_dict
  nullptr, // tp_descr_get
  nullptr, // tp_descr_set
  0, // tp_dictoffset
  nullptr, // tp_init
  nullptr, // tp_alloc
  nullptr, // tp_new
  PyObject_Del, // tp_free
  nullptr, // tp_is_gc
  nullptr, // tp_bases
  nullptr, // tp_mro
  nullptr, // tp_cache
  nullptr, // tp_subclasses
  nullptr, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

PyObject *PyvtkPVLegacyGlyphFilter_CommunicationIds_FromEnum(int val)
{
#ifdef VTK_PY3K
  PyObject *args = Py_BuildValue("(i)", val);
  PyObject *obj = PyLong_Type.tp_new(&PyvtkPVLegacyGlyphFilter_CommunicationIds_Type, args, nullptr);
  Py_DECREF(args);
  return obj;
#else
  PyIntObject *self = PyObject_New(PyIntObject,
    &PyvtkPVLegacyGlyphFilter_CommunicationIds_Type);
  self->ob_ival = val;
  return (PyObject *)self;
#endif
}


static PyObject *
PyvtkPVLegacyGlyphFilter_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkPVLegacyGlyphFilter::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPVLegacyGlyphFilter_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVLegacyGlyphFilter *op = static_cast<vtkPVLegacyGlyphFilter *>(vp);

  char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkPVLegacyGlyphFilter::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPVLegacyGlyphFilter_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkPVLegacyGlyphFilter *tempr = vtkPVLegacyGlyphFilter::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPVLegacyGlyphFilter_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVLegacyGlyphFilter *op = static_cast<vtkPVLegacyGlyphFilter *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkPVLegacyGlyphFilter *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkPVLegacyGlyphFilter::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkPVLegacyGlyphFilter_SetMaximumNumberOfPoints(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetMaximumNumberOfPoints");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVLegacyGlyphFilter *op = static_cast<vtkPVLegacyGlyphFilter *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetMaximumNumberOfPoints(temp0);
    }
    else
    {
      op->vtkPVLegacyGlyphFilter::SetMaximumNumberOfPoints(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkPVLegacyGlyphFilter_GetMaximumNumberOfPoints(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetMaximumNumberOfPoints");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVLegacyGlyphFilter *op = static_cast<vtkPVLegacyGlyphFilter *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetMaximumNumberOfPoints() :
      op->vtkPVLegacyGlyphFilter::GetMaximumNumberOfPoints());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPVLegacyGlyphFilter_GetNumberOfProcesses(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfProcesses");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVLegacyGlyphFilter *op = static_cast<vtkPVLegacyGlyphFilter *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetNumberOfProcesses() :
      op->vtkPVLegacyGlyphFilter::GetNumberOfProcesses());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPVLegacyGlyphFilter_SetUseMaskPoints(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetUseMaskPoints");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVLegacyGlyphFilter *op = static_cast<vtkPVLegacyGlyphFilter *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetUseMaskPoints(temp0);
    }
    else
    {
      op->vtkPVLegacyGlyphFilter::SetUseMaskPoints(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkPVLegacyGlyphFilter_GetUseMaskPoints(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetUseMaskPoints");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVLegacyGlyphFilter *op = static_cast<vtkPVLegacyGlyphFilter *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetUseMaskPoints() :
      op->vtkPVLegacyGlyphFilter::GetUseMaskPoints());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPVLegacyGlyphFilter_SetRandomMode(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetRandomMode");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVLegacyGlyphFilter *op = static_cast<vtkPVLegacyGlyphFilter *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetRandomMode(temp0);
    }
    else
    {
      op->vtkPVLegacyGlyphFilter::SetRandomMode(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkPVLegacyGlyphFilter_GetRandomMode(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetRandomMode");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVLegacyGlyphFilter *op = static_cast<vtkPVLegacyGlyphFilter *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetRandomMode() :
      op->vtkPVLegacyGlyphFilter::GetRandomMode());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPVLegacyGlyphFilter_IsPointVisible(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsPointVisible");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVLegacyGlyphFilter *op = static_cast<vtkPVLegacyGlyphFilter *>(vp);

  vtkDataSet *temp0 = nullptr;
  vtkIdType temp1;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetVTKObject(temp0, "vtkDataSet") &&
      ap.GetValue(temp1))
  {
    int tempr = (ap.IsBound() ?
      op->IsPointVisible(temp0, temp1) :
      op->vtkPVLegacyGlyphFilter::IsPointVisible(temp0, temp1));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPVLegacyGlyphFilter_SetKeepRandomPoints(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetKeepRandomPoints");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVLegacyGlyphFilter *op = static_cast<vtkPVLegacyGlyphFilter *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetKeepRandomPoints(temp0);
    }
    else
    {
      op->vtkPVLegacyGlyphFilter::SetKeepRandomPoints(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkPVLegacyGlyphFilter_GetKeepRandomPoints(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetKeepRandomPoints");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVLegacyGlyphFilter *op = static_cast<vtkPVLegacyGlyphFilter *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetKeepRandomPoints() :
      op->vtkPVLegacyGlyphFilter::GetKeepRandomPoints());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkPVLegacyGlyphFilter_Methods[] = {
  {"IsTypeOf", PyvtkPVLegacyGlyphFilter_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\nReturn 1 if this class type is the same type of (or a subclass\nof) the named class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"IsA", PyvtkPVLegacyGlyphFilter_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type) override;\n\nReturn 1 if this class is the same type of (or a subclass of) the\nnamed class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"SafeDownCast", PyvtkPVLegacyGlyphFilter_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkPVLegacyGlyphFilter\nC++: static vtkPVLegacyGlyphFilter *SafeDownCast(vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkPVLegacyGlyphFilter_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkPVLegacyGlyphFilter\nC++: vtkPVLegacyGlyphFilter *NewInstance()\n\n"},
  {"SetMaximumNumberOfPoints", PyvtkPVLegacyGlyphFilter_SetMaximumNumberOfPoints, METH_VARARGS,
   "V.SetMaximumNumberOfPoints(int)\nC++: virtual void SetMaximumNumberOfPoints(int _arg)\n\nLimit the number of points to glyph\n"},
  {"GetMaximumNumberOfPoints", PyvtkPVLegacyGlyphFilter_GetMaximumNumberOfPoints, METH_VARARGS,
   "V.GetMaximumNumberOfPoints() -> int\nC++: virtual int GetMaximumNumberOfPoints()\n\nLimit the number of points to glyph\n"},
  {"GetNumberOfProcesses", PyvtkPVLegacyGlyphFilter_GetNumberOfProcesses, METH_VARARGS,
   "V.GetNumberOfProcesses() -> int\nC++: virtual int GetNumberOfProcesses()\n\nGet the number of processes used to run this filter.\n"},
  {"SetUseMaskPoints", PyvtkPVLegacyGlyphFilter_SetUseMaskPoints, METH_VARARGS,
   "V.SetUseMaskPoints(int)\nC++: void SetUseMaskPoints(int useMaskPoints)\n\nSet/get whether to mask points\n"},
  {"GetUseMaskPoints", PyvtkPVLegacyGlyphFilter_GetUseMaskPoints, METH_VARARGS,
   "V.GetUseMaskPoints() -> int\nC++: virtual int GetUseMaskPoints()\n\nSet/get whether to mask points\n"},
  {"SetRandomMode", PyvtkPVLegacyGlyphFilter_SetRandomMode, METH_VARARGS,
   "V.SetRandomMode(int)\nC++: void SetRandomMode(int mode)\n\nSet/get flag to cause randomization of which points to mask.\n"},
  {"GetRandomMode", PyvtkPVLegacyGlyphFilter_GetRandomMode, METH_VARARGS,
   "V.GetRandomMode() -> int\nC++: int GetRandomMode()\n\nSet/get flag to cause randomization of which points to mask.\n"},
  {"IsPointVisible", PyvtkPVLegacyGlyphFilter_IsPointVisible, METH_VARARGS,
   "V.IsPointVisible(vtkDataSet, int) -> int\nC++: int IsPointVisible(vtkDataSet *ds, vtkIdType ptId)\n\nIn processing composite datasets, will check if a point is\nvisible as long as the dataset being process if a vtkUniformGrid.\n"},
  {"SetKeepRandomPoints", PyvtkPVLegacyGlyphFilter_SetKeepRandomPoints, METH_VARARGS,
   "V.SetKeepRandomPoints(int)\nC++: void SetKeepRandomPoints(int keepRandomPoints)\n\n"},
  {"GetKeepRandomPoints", PyvtkPVLegacyGlyphFilter_GetKeepRandomPoints, METH_VARARGS,
   "V.GetKeepRandomPoints() -> int\nC++: virtual int GetKeepRandomPoints()\n\n"},
  {nullptr, nullptr, 0, nullptr}
};

static PyTypeObject PyvtkPVLegacyGlyphFilter_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkPVVTKExtensionsDefaultPython.vtkPVLegacyGlyphFilter", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  nullptr, // tp_print
  nullptr, // tp_getattr
  nullptr, // tp_setattr
  nullptr, // tp_compare
  PyVTKObject_Repr, // tp_repr
  nullptr, // tp_as_number
  nullptr, // tp_as_sequence
  nullptr, // tp_as_mapping
  nullptr, // tp_hash
  nullptr, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  PyvtkPVLegacyGlyphFilter_Doc, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  nullptr, // tp_clear
  nullptr, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  nullptr, // tp_iter
  nullptr, // tp_iternext
  nullptr, // tp_methods
  nullptr, // tp_members
  PyVTKObject_GetSet, // tp_getset
  nullptr, // tp_base
  nullptr, // tp_dict
  nullptr, // tp_descr_get
  nullptr, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  nullptr, // tp_init
  nullptr, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  nullptr, // tp_is_gc
  nullptr, // tp_bases
  nullptr, // tp_mro
  nullptr, // tp_cache
  nullptr, // tp_subclasses
  nullptr, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkPVLegacyGlyphFilter_StaticNew()
{
  return vtkPVLegacyGlyphFilter::New();
}

PyObject *PyvtkPVLegacyGlyphFilter_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkPVLegacyGlyphFilter_Type, PyvtkPVLegacyGlyphFilter_Methods,
    "vtkPVLegacyGlyphFilter",
 &PyvtkPVLegacyGlyphFilter_StaticNew);

  PyTypeObject *pytype = &PyvtkPVLegacyGlyphFilter_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkGlyph3D_ClassNew();

  PyObject *d = pytype->tp_dict;
  PyObject *o;

  PyType_Ready(&PyvtkPVLegacyGlyphFilter_CommunicationIds_Type);
  PyvtkPVLegacyGlyphFilter_CommunicationIds_Type.tp_new = nullptr;
  vtkPythonUtil::AddEnumToMap(&PyvtkPVLegacyGlyphFilter_CommunicationIds_Type);

  o = (PyObject *)&PyvtkPVLegacyGlyphFilter_CommunicationIds_Type;
  if (PyDict_SetItemString(d, "CommunicationIds", o) != 0)
  {
    Py_DECREF(o);
  }

  for (int c = 0; c < 2; c++)
  {
    typedef vtkPVLegacyGlyphFilter::CommunicationIds cxx_enum_type;

    static const struct { const char *name; cxx_enum_type value; }
      constants[2] = {
        { "GlyphNPointsGather", vtkPVLegacyGlyphFilter::GlyphNPointsGather },
        { "GlyphNPointsScatter", vtkPVLegacyGlyphFilter::GlyphNPointsScatter },
      };

    o = PyvtkPVLegacyGlyphFilter_CommunicationIds_FromEnum(constants[c].value);
    if (o)
    {
      PyDict_SetItemString(d, constants[c].name, o);
      Py_DECREF(o);
    }
  }

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

void PyVTKAddFile_vtkPVLegacyGlyphFilter(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkPVLegacyGlyphFilter_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkPVLegacyGlyphFilter", o) != 0)
  {
    Py_DECREF(o);
  }

}

